@ECHO OFF
SET LogPath=C:\OEM\AcerLogs\%1.log
Echo.>>%LogPath%
ECHO %DATE% %TIME% [Log START]  ================== %~dpnx0 =================== >> %LogPath%
SETLOCAL ENABLEDELAYEDEXPANSION

ECHO %DATE% %TIME% [Log TRACE]  reg query HKLM\Software\OEM\Metadata /v sys >>%LogPath% 2>&1
reg query HKLM\Software\OEM\Metadata /v sys >>%LogPath% 2>&1
FOR /F "tokens=3 delims= " %%T IN ('reg query HKLM\Software\OEM\Metadata /v sys') DO set @sys=%%T
ECHO %DATE% %TIME% [Log TRACE]  call :%1 >>%LogPath%
call :%1


SETLOCAL DISABLEDELAYEDEXPANSION
ECHO %DATE% %TIME% [Log LEAVE]  ================== %~dpnx0 =================== >> %LogPath%
echo. >> %LogPath%
exit /b 0



:FirstBoot
IF /i "%@sys%" EQU "DTP" exit /b 0
pushd .\LMDriver
ECHO %DATE% %TIME% [Log TRACE]  cmd /c %CD%InstallLMDriver.exe >>%LogPath%
cmd /c InstallLMDriver.exe
popd
exit /b 0



:UserAlaunch
call :%@sys%
exit /b 0


:DTP
ECHO %DATE% %TIME% [Log TRACE]  setup.exe -s >>%LogPath%
setup.exe -s
exit /b 0


:PTB
set @type=Notebook
ECHO %DATE% %TIME% [Log TRACE]  reg query HKLM\Software\OEM\Metadata /v type >>%LogPath%
reg query HKLM\Software\OEM\Metadata /v type >>%LogPath% 2>&1
FOR /F "tokens=3 delims= " %%T IN ('reg query HKLM\Software\OEM\Metadata /v type') DO set @type=%%T
ECHO %DATE% %TIME% [Log TRACE]  type=[%@type%] >> %LogPath%

IF /I "%@type%"=="Detachable" (
	ECHO !DATE! !TIME! [Log TRACE]  Workaround, set the metadata type to Tablet for LumiFlex setup >> %LogPath%
	call :SetMetadata Tablet
)
ECHO %DATE% %TIME% [Log TRACE]  setup.exe -s >>%LogPath%
setup.exe -s

IF /I "%@type%"=="Detachable" (
	ECHO !DATE! !TIME! [Log TRACE]  Wait for setup completed >> %LogPath%
	timeout /t 5 /nobreak
	ECHO !DATE! !TIME! [Log TRACE]  Rollback the metadata type >> %LogPath%
	call :SetMetadata %@type%
)
:: For NB project only
ECHO %DATE% %TIME% [Log TRACE]  regedit /s DisableNetworkSharing.reg >>%LogPath%
regedit /s DisableNetworkSharing.reg >>%LogPath% 2>&1
exit /b 0


:SetMetadata
ECHO %DATE% %TIME% [Log TRACE]  Set metadata type to %1 >> %LogPath%
reg add   HKLM\Software\OEM\Metadata /v "type" /t REG_SZ /d %1 /F
timeout /t 1 /nobreak
reg query HKLM\Software\OEM\Metadata /v type >> %LogPath%
IF NOT "%PROCESSOR_ARCHITECTURE%"=="x86" (
	reg add   HKLM\Software\Wow6432Node\OEM\Metadata /v "type" /t REG_SZ /d %1 /F
	timeout /t 1 /nobreak
	reg query HKLM\Software\Wow6432Node\OEM\Metadata /v type >> %LogPath%
)
exit /b 0